//
// Common Source Code Project p keycode.cfg 
//
// keycode.cfg  256oCg̃oCit@C
// 256vf̃oCgzŁAVK_xx CfbNXƂAϊ VK_yy i[Ă
//
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

char buf[256];
unsigned char kcnv[256];

struct {
  char *keyword;
  unsigned char vk;
} keyword_to_val[] = {

  { "VK_BACK",           0x08 },  // Backspace
  { "VK_TAB",            0x09 },
  { "VK_CLEAR",          0x0C },
  { "VK_RETURN",         0x0D },
  { "VK_SHIFT",          0x10 },
  { "VK_CONTROL",        0x11 },
  { "VK_MENU",           0x12 },  // Alt
  { "VK_PAUSE",          0x13 },
  { "VK_CAPITAL",        0x14 },  // CapsLock
  { "VK_KANA",           0x15 },  // J^Ji/Ђ炪 [}
  { "VK_KANJI",          0x19 },  // p/Sp 
  { "VK_ESCAPE",         0x1B },
  { "VK_CONVERT",        0x1C },  // ϊ
  { "VK_NONCONVERT",     0x1D },  // ϊ
  { "VK_ACCEPT",         0x1E },
  { "VK_MODECHANGE",     0x1F },
  { "VK_SPACE",          0x20 },
  { "VK_PRIOR",          0x21 },  // Page Up
  { "VK_NEXT",           0x22 },  // Page Down
  { "VK_END",            0x23 },
  { "VK_HOME",           0x24 },
  { "VK_LEFT",           0x25 },  // J[\L[ 
  { "VK_UP",             0x26 },  // J[\L[ 
  { "VK_RIGHT",          0x27 },  // J[\L[ 
  { "VK_DOWN",           0x28 },  // J[\L[ 
  { "VK_SELECT",         0x29 },
  { "VK_PRINT",          0x2A },
  { "VK_EXECUTE",        0x2B },
  { "VK_SNAPSHOT",       0x2C },
  { "VK_INSERT",         0x2D },
  { "VK_DELETE",         0x2E },
  { "VK_HELP",           0x2F },
  { "VK_LWIN",           0x5B },  // Windows
  { "VK_RWIN",           0x5C },  // EWindows
  { "VK_APPS",           0x5D },  // AvP[VL[
  { "VK_SLEEP",          0x5F },
  { "VK_NUMPAD0",        0x60 },  // eL[ 0
  { "VK_NUMPAD1",        0x61 },  // eL[ 1
  { "VK_NUMPAD2",        0x62 },  // eL[ 2
  { "VK_NUMPAD3",        0x63 },  // eL[ 3
  { "VK_NUMPAD4",        0x64 },  // eL[ 4
  { "VK_NUMPAD5",        0x65 },  // eL[ 5
  { "VK_NUMPAD6",        0x66 },  // eL[ 6
  { "VK_NUMPAD7",        0x67 },  // eL[ 7
  { "VK_NUMPAD8",        0x68 },  // eL[ 8
  { "VK_NUMPAD9",        0x69 },  // eL[ 9
  { "VK_MULTIPLY",       0x6A },  // eL[ *
  { "VK_ADD",            0x6B },  // eL[ +
  { "VK_SEPARATOR",      0x6C },  // eL[ ,
  { "VK_SUBTRACT",       0x6D },  // eL[ -
  { "VK_DECIMAL",        0x6E },  // eL[ .
  { "VK_DIVIDE",         0x6F },  // eL[ /
  { "VK_F1",             0x70 },
  { "VK_F2",             0x71 },
  { "VK_F3",             0x72 },
  { "VK_F4",             0x73 },
  { "VK_F5",             0x74 },
  { "VK_F6",             0x75 },
  { "VK_F7",             0x76 },
  { "VK_F8",             0x77 },
  { "VK_F9",             0x78 },
  { "VK_F10",            0x79 },
  { "VK_F11",            0x7A },
  { "VK_F12",            0x7B },
  { "VK_F13",            0x7C },
  { "VK_F14",            0x7D },
  { "VK_F15",            0x7E },
  { "VK_F16",            0x7F },
  { "VK_F17",            0x80 },
  { "VK_F18",            0x81 },
  { "VK_F19",            0x82 },
  { "VK_F20",            0x83 },
  { "VK_F21",            0x84 },
  { "VK_F22",            0x85 },
  { "VK_F23",            0x86 },
  { "VK_F24",            0x87 },
  { "VK_NUMLOCK",        0x90 },  // NumLock
  { "VK_SCROLL",         0x91 },  // ScrlLock
  { "VK_OEM_NEC_EQUAL",  0x92 },
//  { "VK_LSHIFT",         0xA0 },
//  { "VK_RSHIFT",         0xA1 },
//  { "VK_LCONTROL",       0xA2 },
//  { "VK_RCONTROL",       0xA3 },
//  { "VK_LMENU",          0xA4 },
//  { "VK_RMENU",          0xA5 },
  { "VK_BROWSER_BACK",   0xA6 },
  { "VK_BROWSER_FORWARD",     0xA7 },
  { "VK_BROWSER_REFRESH",     0xA8 },
  { "VK_BROWSER_STOP",        0xA9 },
  { "VK_BROWSER_SEARCH",      0xAA },
  { "VK_BROWSER_FAVORITES",   0xAB },
  { "VK_BROWSER_HOME",        0xAC },

  { "VK_VOLUME_MUTE",         0xAD },
  { "VK_VOLUME_DOWN",         0xAE },
  { "VK_VOLUME_UP",           0xAF },
  { "VK_MEDIA_NEXT_TRACK",    0xB0 },
  { "VK_MEDIA_PREV_TRACK",    0xB1 },
  { "VK_MEDIA_STOP",          0xB2 },
  { "VK_MEDIA_PLAY_PAUSE",    0xB3 },
  { "VK_LAUNCH_MAIL",         0xB4 },
  { "VK_LAUNCH_MEDIA_SELECT", 0xB5 },
  { "VK_LAUNCH_APP1",         0xB6 },
  { "VK_LAUNCH_APP2",         0xB7 },

  { "VK_OEM_1",          0xBA },  // {L[{[h :
  { "VK_OEM_PLUS",       0xBB },  // {L[{[h ;
  { "VK_OEM_COMMA",      0xBC },  // {L[{[h ,
  { "VK_OEM_MINUS",      0xBD },  // {L[{[h -
  { "VK_OEM_PERIOD",     0xBE },  // {L[{[h .
  { "VK_OEM_2",          0xBF },  // {L[{[h /
  { "VK_OEM_3",          0xC0 },  // {L[{[h @
  { "VK_OEM_4",          0xDB },  // {L[{[h [
  { "VK_OEM_5",          0xDC },  // {L[{[h 
  { "VK_OEM_6",          0xDD },  // {L[{[h ]
  { "VK_OEM_7",          0xDE },  // {L[{[h ^
  { "VK_OEM_8",          0xDF },
  { "VK_OEM_102",        0xE2 },  // {L[{[h 
  { 0, 0 }
};


char *skipspaces(char *str) {
  char c, *p;
  p = str;
  while ((c = *p) != 0) {
    if (c > 0 && c <= 0x20) {
      p++;
    } else if (c == '#') {
      while (*p != 0) p++;
    } else {
      break;
    }
  }
  return p;
}
unsigned char getVK(char **str) {
  char c, *p, *q;
  char token[256];
  int i;

  p = skipspaces(*str);
  q = token;
  while (*p != 0) {
    c = *p++;
    if (c > 0 && c <= 0x20) {
      *q = 0;
      break;
    } else if (c == '#') {
      *q = 0;
      while (*p != 0) p++;
      break;
    }
    *q++ = c;
  }
  *q = 0;
  *str = p;
  if (token[0] == 0) return 0;
  if (token[1] == 0) {
    if ((token[0] >= '0' && token[0] <= '9') ||
        (token[0] >= 'A' && token[0] <= 'Z')) return token[0];
    if (token[0] >= 'a' && token[0] <= 'z') return token[0] - 'a' + 'A';
  }
  if (token[0] == '0' && token[1] == 'x' &&
      isxdigit(token[2]) && isxdigit(token[3])) {
    sscanf_s(token, "0x%x", &i);
    return (unsigned char)i;
  }
  for (i=0; keyword_to_val[i].vk != 0; i++) {
    if (!strcmpi(keyword_to_val[i].keyword, token)) {
      return keyword_to_val[i].vk;
    }
  }
  return 0;
}

//
// MAIN
//
int main(int argc, char **argv) {
  FILE *fp;
  unsigned char VKfrom, VKto;
  char *p;
  int i, l;

  if (argc != 2) {
    fprintf(stdout, "Usage: make_cscp_keycfg <infile>\n"
                    "  Common Source Code Project G~[^p keycode.cfg 𐶐܂\n\n");
    exit(0);
  }

  //
  // ftHg̃L[ϊe[u
  //
  for (i=0; i<256; i++) kcnv[i] = (unsigned char)i;

  //
  // w̃t@CƂɕϊe[uύX
  //
  fp = fopen(argv[1], "r");
  if (fp == NULL) {
    fprintf(stderr, "%s J܂\n", argv[1]);
  } else {
    l = 0;
    while (fgets(buf, 256, fp) != NULL) {
      l++;
      p = skipspaces(buf);
      if (*p == 0) continue; // s
      VKfrom = getVK(&p);
      VKto   = getVK(&p);
      if (VKfrom == 0 || VKto == 0) {
        fprintf(stderr, "Syntax error in %d\n", l);
        fclose(fp);
        exit(0);
      }
//      printf("From 0x%02X to 0x%02X\n", VKfrom, VKto);
      if (kcnv[VKfrom] == VKfrom) {
        // ܂ύXĂȂL[
	kcnv[VKfrom] = VKto;
	kcnv[VKto  ] = 0x87;  // F24 (_~[)
      } else {
        // łɕύXL[
        kcnv[VKfrom] = VKto;
      }
    }
    fclose(fp);

    //
    // keycode.cfg 
    //
    fp = fopen("keycode.cfg", "wb");
    if (fp == NULL) {
      fprintf(stderr, "keycode.cfg 쐬ł܂\n");
      exit(0);
    } else if (fwrite(kcnv, 1, 256, fp) == 256) {
      fprintf(stderr, "keycode.cfg 쐬܂\n");
    } else {
      fprintf(stderr, "keycode.cfg ̐ɃG[܂\n");
    }
    fclose(fp);
  }
  exit(0);
}

